// This file is part of Substrate.

// Copyright (C) 2021 Parity Technologies (UK) Ltd.
// SPDX-License-Identifier: Apache-2.0

// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

//! Autogenerated weights for pallet_capital_distribution
//!
//! THIS FILE WAS AUTO-GENERATED USING THE SUBSTRATE BENCHMARK CLI VERSION 3.0.0
//! DATE: 2021-09-22, STEPS: [100, ], REPEAT: 5, LOW RANGE: [], HIGH RANGE: []
//! EXECUTION: Some(Wasm), WASM-EXECUTION: Compiled, CHAIN: None, DB CACHE: 512

// Executed Command:
// ./target/release/polymesh
// benchmark
// -s
// 100
// -r
// 5
// -p=pallet_capital_distribution
// -e=*
// --heap-pages
// 4096
// --db-cache
// 512
// --execution
// wasm
// --wasm-execution
// compiled
// --output
// ./pallets/weights/src/
// --template
// ./.maintain/frame-weight-template.hbs
// --raw

#![allow(unused_parens)]
#![allow(unused_imports)]

use polymesh_runtime_common::{RocksDbWeight as DbWeight, Weight};

/// Weights for pallet_capital_distribution using the Substrate node and recommended hardware.
pub struct WeightInfo;
impl pallet_corporate_actions::distribution::WeightInfo for WeightInfo {
    fn distribute() -> Weight {
        (142_494_000 as Weight)
            .saturating_add(DbWeight::get().reads(13 as Weight))
            .saturating_add(DbWeight::get().writes(2 as Weight))
    }
    fn claim(t: u32, w: u32) -> Weight {
        (492_552_000 as Weight)
            // Standard Error: 6_000
            .saturating_add((316_000 as Weight).saturating_mul(t as Weight))
            // Standard Error: 6_000
            .saturating_add((176_000 as Weight).saturating_mul(w as Weight))
            .saturating_add(DbWeight::get().reads(29 as Weight))
            .saturating_add(DbWeight::get().writes(11 as Weight))
    }
    fn push_benefit(t: u32, w: u32) -> Weight {
        (538_560_000 as Weight)
            // Standard Error: 7_000
            .saturating_add((300_000 as Weight).saturating_mul(t as Weight))
            // Standard Error: 7_000
            .saturating_add((157_000 as Weight).saturating_mul(w as Weight))
            .saturating_add(DbWeight::get().reads(30 as Weight))
            .saturating_add(DbWeight::get().writes(11 as Weight))
    }
    fn reclaim() -> Weight {
        (115_549_000 as Weight)
            .saturating_add(DbWeight::get().reads(9 as Weight))
            .saturating_add(DbWeight::get().writes(2 as Weight))
    }
    fn remove_distribution() -> Weight {
        (93_784_000 as Weight)
            .saturating_add(DbWeight::get().reads(8 as Weight))
            .saturating_add(DbWeight::get().writes(2 as Weight))
    }
}
